// Rejestrator temperatury - KAmduino UNO, czytnik kart pamięci, zegar czasu rzeczywistego oraz termometr LM35DZ
// Autor: Patryk Mądry 
// Mikrokontroler 2017 r.

// RTC
#include <Wire.h>
#include "RTClib.h"

// Czytnik kart pamięci 
#include <SPI.h>
#include <SD.h>

RTC_DS1307 rtc; // Uruchomienie zegara RTC

const int chipSelect = 4; 
int licznik =0;

// Czujnik temperatury 
float napiecie = 0; //Zmienna przechowująca zmierzoną temperaturę 
float temperatura = 0; // Zmienna przechowująca zmierzoną temperaturę 


void setup() {
  
  Serial.begin(9600);
  
   // Sprawdzenie czy moduł z RTC jest podłączony 
   if (! rtc.begin()) {
      Serial.println("Nie znaleziono RTC");
   }

   if (! rtc.isrunning()) {
   // Ustawienie początkowej daty i godziny 
   rtc.adjust(DateTime(F(__DATE__), F(__TIME__))); // Pobranie daty i godziny z komputera PC
   // rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0)); // Ręczne ustawienie daty i godziny, tutaj: 21 Stycznia 2014
    
   }

   // Sprawdzenie działania czytnika kart pamięci
   if (!SD.begin(chipSelect)) 
   {
      Serial.println("Card failed, or not present");
      return;
   }


}

void loop() 
{

  // Pomiar temperatury
  int odczyt = analogRead(A0);
  napiecie = (odczyt * 5.0)/1024.00;
  temperatura = napiecie *100;
  
  String tekst_do_zapisu ="";
  
  DateTime now = rtc.now();

  // Tworzenie tekstu do zapisu na kartę pamieci
  tekst_do_zapisu += String(now.hour());
  tekst_do_zapisu += ':';
  tekst_do_zapisu += String(now.minute());
  tekst_do_zapisu += ':';
  tekst_do_zapisu += String(now.second());
  tekst_do_zapisu += " ";
  tekst_do_zapisu += String(now.day());
  tekst_do_zapisu += '/';
  tekst_do_zapisu += String(now.month());
  tekst_do_zapisu += '/';
  tekst_do_zapisu += String(now.year());
  tekst_do_zapisu += ' ';
  tekst_do_zapisu += String(licznik);
  tekst_do_zapisu += ' ';
  tekst_do_zapisu += String(temperatura); 
  licznik++;

 
  // Otworzenie lub stworzenie pliku o nazwie temp.txt
  File plik = SD.open("temp.txt", FILE_WRITE);

  
  if (plik)
  {
    plik.println(tekst_do_zapisu);
    plik.close();
    Serial.println(tekst_do_zapisu);
  }
  else 
  {
    Serial.println("Blad otworzenia pliku ");
  }
  
  delay(5000); // Czas co ile będzie dokonywany zapis na kartę pamieci
  
 
}
